/***************************************************************************
                   INTERNAL FUNCTION PROTOTYPES                       
****************************************************************************/

/***************************************************************************
                             FILE: TER.C 
****************************************************************************/
BOOL    MessagePending(PTERWND);
LRESULT TerEraseBackground(PTERWND,HDC);
BOOL    TerPostProcessing(PTERWND,UINT,WPARAM,LPARAM);
BOOL    TerSetBkColor(PTERWND,COLORREF);
BOOL    TerSetClipRgn(PTERWND);
BOOL    TerResetClipRgn(PTERWND);
BOOL    TerSetCaretPos(PTERWND);
BOOL    TerTranslateAccelerator(PTERWND,UINT,WPARAM,LPARAM,HANDLE);
BOOL    TextSegmentExists(PTERWND,int,int,RECT far *,int,LPBYTE);
LRESULT CALLBACK _export TerWndProc(HWND,UINT,WPARAM,LPARAM);
LRESULT TerDefWindowProc(HWND,UINT,WPARAM,LPARAM);
int     DeleteTextSeg(PTERWND,int);
int     SetScrollBars(PTERWND);
int     TerInitMenu(PTERWND,HMENU);
int     TerLButtonDown(PTERWND,BOOL,UINT,WPARAM,LPARAM);
int     CALLBACK _export WEP(int);
void    AdjustHiddenPos(PTERWND);


/***************************************************************************
                             FILE: TER1.C 
****************************************************************************/
BOOL    DrawDottedLine(PTERWND,HDC,int,int,int,int);
BOOL    DrawShadowLine(PTERWND,HDC,int,int,int,int,HPEN,HPEN);
BOOL    IsHypertext(PTERWND,int);
BOOL    SendLinkMessage(PTERWND,BOOL);
BOOL    HasSameParaBorder(PTERWND,int,int);
int     ClearEOL(PTERWND,HDC,int,int,int,int);
int     DisplayStatus(PTERWND);
int     DisplayStatusInfo(PTERWND);
int     DisplayText(PTERWND,HDC,int,int,int,int,LPBYTE,int,long,BOOL,BYTE);
int     DrawParaBorder(PTERWND,HDC,RECT far *,BOOL);
int     TerPictOut(PTERWND,HDC,int,int,RECT far *,int,int);
int     PictOut(PTERWND,HDC,int,int,int,int);
int     RepaintTer(PTERWND);
int     SetFont(PTERWND,HDC,BYTE,BYTE);
int     SetColor(PTERWND,HDC,BYTE,BYTE);
int     SetParaBorder(PTERWND,long);
int     TerSetHilight(PTERWND,WPARAM,DWORD);
int     TerSetLineHilight(PTERWND);
int     TerSetCharHilight(PTERWND);
int     TerTextOut(PTERWND,HDC,int,int,RECT far *,LPBYTE,int);
int     WriteFrameSpace(PTERWND,HDC,long,int,int);
int     WriteSpace(PTERWND,HDC,long,int,int,int);
int     WriteSpaceRect(PTERWND,HDC,RECT far *);
int     WriteTab(PTERWND,HDC,long,int,int);
long    GetStatusLineNo(PTERWND);
void    DrawRuler(PTERWND,BOOL);
void    GetWinDimension(PTERWND);
void    HorScrollCheck(PTERWND);
void    PaintFrames(PTERWND,long);
void    PaintRows(PTERWND,long,long);
void    PaintTer(PTERWND);
void    SetTerWindowOrg(PTERWND);

/***************************************************************************
                             FILE: TER2.C 
****************************************************************************/
BOOL    DisplacePointers(PTERWND,long,long);
BOOL    IsProtectedChar(PTERWND,long,int);
int     DoRulerClick(PTERWND,UINT,DWORD);
int     DrawFrameBorder(PTERWND,int,int,int,int,int,int);
int     GetSpaceAdj(PTERWND,long,int);
int     GetTabPos(PTERWND,struct StrTab far *,int,int far *,int far *);
int     GetTabWidth(PTERWND,long,int,int);
int     TerAscii(PTERWND,BYTE);
int     TerBackSpace(PTERWND);
int     TerBackTab(PTERWND);
int     TerBeginFile(PTERWND);
int     TerBeginLine(PTERWND);
int     TerCtrlDown(PTERWND);
int     TerCtrlUp(PTERWND);
int     TerDel(PTERWND);
int     TerDeleteLine(PTERWND);
int     TerDoubleClick(PTERWND);
int     TerDown(PTERWND);
int     TerEndFile(PTERWND);
int     TerEndLine(PTERWND);
int     TerInsert(PTERWND);
int     TerInsertLineAft(PTERWND);
int     TerInsertLineBef(PTERWND);
int     TerJoinLine(PTERWND);
int     TerLeft(PTERWND);
int     TerMousePos(PTERWND,DWORD);
int     TerNextWord(PTERWND);
int     TerPageDn(PTERWND,BOOL);
int     TerPageHorz(PTERWND,BYTE,int);
int     TerPageLeft(PTERWND,BOOL);
int     TerPageRight(PTERWND,BOOL);
int     TerPageUp(PTERWND,BOOL);
int     TerPosLine(PTERWND,long);
int     TerPrevWord(PTERWND);
int     TerReturn(PTERWND);
int     TerRight(PTERWND);
int     TerSetCursorShape(PTERWND,DWORD,BOOL);
int     TerSplitLine(PTERWND,int);
int     TerInsertTab(PTERWND);
int     TerUp(PTERWND);
int     TerWinDown(PTERWND);
int     TerWinLeft(PTERWND);
int     TerWinRight(PTERWND);
int     TerWinUp(PTERWND);
int     WordWrap(PTERWND,long,long);
int     WrapMakeBuffer(PTERWND,long,long);
int     WrapParseBuffer(PTERWND,long);
void    LineAlloc(PTERWND,long,UINT,UINT);
void    MoveLineArrays(PTERWND,long,long,BYTE);
void    MoveLineData(PTERWND,long,int,int,BYTE);

/***************************************************************************
                             FILE: TER3.C 
****************************************************************************/
BOOL    AnchorParaFound(PTERWND,long);
int     ColToUnits(PTERWND,int,long,int);
int     DeleteFrame(PTERWND);
int     FitPictureInFrame(PTERWND,long,BOOL);
int     FreeLine(PTERWND,long);
int     GetCurPage(PTERWND,long);
int     GetFrame(PTERWND,long);
int     GetFrameSpace(PTERWND,long,RECT far *,int far *,int far *,int far *);
int     GetLineHeight(PTERWND,long,int far *);
int     GetLineWidth(PTERWND,long,BOOL);
int     GetLineSpacing(PTERWND,long,int,int far *,int far *,BOOL);
int     GetParaFrameSlot(PTERWND);
int     GetRowHeight(PTERWND,long);
int     GetRowX(PTERWND,long);
int     GetRowY(PTERWND,long);
int     InitLine(PTERWND,long);
int     InsertPageNumber(PTERWND);
int     LineToUnits(PTERWND,long);
int     RecalcParaFrame(PTERWND);
int     ScrLineHt(PTERWND,long);
int     SetYOrigin(PTERWND,long);
int     TerWrapWidth(PTERWND,long);
int     UnitsToCol(PTERWND,int,long);
long    AddCrLf(PTERWND,long,BYTE huge *,BYTE huge *);
long    GetParaFrameLine(PTERWND,long);
long    RowColToAbs(PTERWND,long,int);
long    UnitsToLine(PTERWND,int,int);
void    AbsToRowCol(PTERWND,long,long far *,int far *);
void    SaveUndo(PTERWND,long,int,long,int,BYTE);

/***************************************************************************
                             FILE: TER_BAR.C 
****************************************************************************/
BOOL CALLBACK _export BarFontSubclass(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK _export BarPointSubclass(HWND,UINT,WPARAM,LPARAM);
BOOL CreateToolBar(PTERWND);
BOOL DestroyToolBar(PTERWND);
BOOL CALLBACK _export ToolBarProc(HWND,UINT,WPARAM,LPARAM);
HWND GetComboEditWindow(HWND,int);
BOOL ToggleToolBar(PTERWND);
BOOL UpdateToolBar(PTERWND);

/***************************************************************************
                             FILE: TER_BLK.C 
****************************************************************************/
BOOL    IsProtected(PTERWND);
int     BlockCopy(PTERWND);
int     BlockDelete(PTERWND);
int     BlockMove(PTERWND);
int     CopyCharBlock(PTERWND,int);
int     CopyFromClipboard(PTERWND,UINT);
int     CopyLineBlock(PTERWND,BOOL);
int     CopyToClipboard(PTERWND,WPARAM);
int     DeleteCharBlock(PTERWND,int);
int     DeleteLineBlock(PTERWND,BOOL);
int     EditPicture(PTERWND);
int     NextBufferLine(PTERWND,struct StructTextBuf far *);
int     NormalizeBlock(PTERWND);
int     TerUndo(PTERWND);
int     TerCreateMetafile(PTERWND,HGLOBAL,int);
void    InsertBuffer(PTERWND,BYTE huge *,BYTE huge *,int huge *,BOOL);

/***************************************************************************
                             FILE: TER_DLG.C 
****************************************************************************/
int     CALLBACK _export CellBorderParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export CellShadingParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ClearTabParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export CtlDlgFn(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export DeleteCellsParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export EditPictureParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export FileParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export FontParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ZoomSubclass(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export InsertObjectParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export JumpParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PageParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ParaBoxParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ParaSpaceParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export PasteSpecialParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PrintAbortParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export PrintPreviewProc(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export RangeParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export ReplaceParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export RowPositionParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export SearchParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export SectionParam(HWND,UINT,WPARAM,LPARAM);
BOOL    CALLBACK _export TableParam(HWND,UINT,WPARAM,LPARAM);
int     CALLBACK _export TerEnumFonts(LPLOGFONT,LPTEXTMETRIC,short,LPBYTE);
BOOL    CALLBACK _export UndoParam(HWND,UINT,WPARAM,LPARAM);

/***************************************************************************
                             FILE: TER_DRAG.C 
****************************************************************************/
BOOL    DeleteDragObjects(PTERWND,int,int);  
BOOL    DragApply(PTERWND,int,int);
BOOL    DragCellSize(PTERWND,int);
BOOL    DragFrameMove(PTERWND,int,int);
BOOL    DragPictFrameSize(PTERWND,int,int,int);
BOOL    DragRowIndent(PTERWND,int);
BOOL    DragRulerIndent(PTERWND,int);
BOOL    DragRulerTab(PTERWND,int);
BOOL    DrawDragCellLine(PTERWND);
BOOL    DrawDragHotSpots(PTERWND,int);
BOOL    DrawDragFrameRect(PTERWND);
BOOL    DrawDragFrameTabs(PTERWND);
BOOL    DrawDragPictRect(PTERWND);
BOOL    DrawDragRulerIndent(PTERWND);
BOOL    DrawDragRulerTab(PTERWND);
BOOL    ShowFrameDragObjects(PTERWND,int);
BOOL    ShowPictureDragObjects(PTERWND,int);
BOOL    TerDragObject(PTERWND,DWORD);
int     TerDrawLine(PTERWND,int,int,int,int,HPEN,RECT far *,BOOL);
int     TerDrawPolygon(PTERWND,POINT far *,int,HPEN,HBRUSH,RECT far *,BOOL);
int     GetDragObjectSlot(PTERWND);  
int     TerDrawRect(PTERWND,RECT far *,HPEN,BOOL,BOOL);

/***************************************************************************
                             FILE: TER_FMT.C 
****************************************************************************/
BOOL    CharFmt(PTERWND,BYTE (*GetNewFontId)(PTERWND,BYTE,DWORD,DWORD), DWORD,DWORD,BOOL);
BOOL    ReadCfmt(PTERWND,LPBYTE,BYTE huge *,long,BYTE);
BOOL    ReadFileInfo(PTERWND,LPBYTE,BYTE huge *,BYTE,BOOL);
BOOL    SaveCfmt(PTERWND,LPBYTE,BYTE huge *,long,BYTE);
BOOL    TerColors(PTERWND,BOOL);
BYTE    GetCharSet(PTERWND,HDC,LPBYTE,BYTE far *);
BYTE    GetCurChar(PTERWND,long,int);
BYTE    GetNewBkColor(PTERWND,BYTE,DWORD,DWORD); 
BYTE    GetNewColor(PTERWND,BYTE,DWORD,DWORD); 
BYTE    GetNewFieldId(PTERWND,BYTE,DWORD,DWORD); 
BYTE    GetNewStyle(PTERWND,BYTE,DWORD,DWORD);
BYTE    GetNewPointSize(PTERWND,BYTE,DWORD,DWORD);
BYTE    GetNewTypeFace(PTERWND,BYTE,DWORD,DWORD);
LPBYTE   OpenCfmt(PTERWND,long);
int     CharFmtChr(PTERWND,BYTE (*GetNewFontId)(PTERWND,BYTE,DWORD,DWORD),DWORD,DWORD,BOOL);
int     CharFmtLine(PTERWND,BYTE (*GetNewFontId)(PTERWND,BYTE,DWORD,DWORD),DWORD,DWORD,BOOL);
int     ClearTabDlg(PTERWND);
int     CreateOneFont(PTERWND,HDC,int,BOOL);
int     DeleteTerObject(PTERWND,int);
int     FindOpenSlot(PTERWND);
int     FmtAlloc(PTERWND,long,int,int);
int     GetCurCfmt(PTERWND,long,int);
int     GetEffectiveCfmt(PTERWND);
int     GetNewFont(PTERWND,int,LPBYTE,int,UINT,COLORREF,COLORREF,int,int);
int     GetParaRange(PTERWND,LPLONG,LPLONG);
int     InitTerObject(PTERWND,int);
int     NewParaId(PTERWND,int,int,int,int,int,int,int,UINT,int,int,int,int,unsigned);
int     NewTabId(PTERWND,int,struct StrTab far *);
int     RecreateFonts(PTERWND,HDC);
int     ReleaseFonts(PTERWND);
int     SetPointSizes(PTERWND,HWND,LPBYTE,int); 
int     TerFonts(PTERWND);
int     TerParaBorder(PTERWND);
int     TerParaSpacing(PTERWND);
int     TypeFaceChar(PTERWND,LPBYTE,int,BOOL);
int     TypeFaceLine(PTERWND,LPBYTE,int,BOOL);
int     XlateSizeForPrt(PTERWND,int);
long    CfmtNeeded(PTERWND);
void    CloseCfmt(PTERWND,long);
void    CompressCfmt(PTERWND,long);
void    ExpandCfmt(PTERWND,long);

/***************************************************************************
                             FILE: TER_INIT.C 
****************************************************************************/
BOOL    InitTer(HWND,CREATESTRUCT far *);
BOOL    InitVariables(PTERWND);
BOOL    InitWinProp(PTERWND);
int     AllocArrayMem(PTERWND);
int     AllocWrapBuf(PTERWND);
int     CreateUserParam(struct arg_list far *,CREATESTRUCT far *);
int     InitPrinter(PTERWND);
void    AbortTer(PTERWND,LPBYTE,int);

/***************************************************************************
                             FILE: TER_IO.C 
****************************************************************************/
BOOL    AttachSectionData(PTERWND);
BOOL    GetFileName(PTERWND,BOOL,LPBYTE,LPBYTE);
BOOL    TerRead(PTERWND,LPBYTE);
BOOL    TerSave(PTERWND,LPBYTE);
BOOL    TerSaveAs(PTERWND,LPBYTE);
int     CalcPageDim(PTERWND,long,int far *,int far *,int far *,int far *,int far *);
int     CALLBACK _export PrintProc(HDC,int);
int     GetLineLen(PTERWND,LPBYTE,LPBYTE,int,int,int);
int     GetPrtTabPos(PTERWND,struct StrTab far *,int,int far *,int far *);
int     GetPrtTabWidth(PTERWND,int,int,struct StrTabw far *);
int     PaintPrintPreview(PTERWND);
int     PrePreview(PTERWND);
int     PreviewOnePage(PTERWND,HDC,RECT far *rect,int,BOOL);
int     PreviewDown(PTERWND, BOOL);
int     PreviewRight(PTERWND, BOOL);
int     PreviewLeft(PTERWND, BOOL);
int     PreviewUp(PTERWND, BOOL);
int     PostPreview(PTERWND);
int     PrintFrameBorder(PTERWND,HDC,int,int,int,int);
int     PrintFrameBorderShading(PTERWND,HDC,int,int,int);
int     PrintParaShading(PTERWND,HDC,int,int,int,int,int);
int     PrintViewMode(PTERWND,HDC,long,long);
int     PrintOneLine(PTERWND,HDC,int,int,LPBYTE,LPBYTE,int,int,int,struct StrTabw far *,int,int,int);
int     PrintOneSegment(PTERWND,HDC,int,int,int,LPBYTE,int,int);
int     SpoolIt(PTERWND,HDC);
int     TerFarRead(PTERWND,BYTE,FILE TERFAR *,BYTE huge *,long far *,long,long,BYTE huge *);
int     TerFarWrite(PTERWND,BYTE,FILE TERFAR *,BYTE huge *,long far *,long,long,BYTE huge *);
int     TerPageOptions(PTERWND);
int     TerPrintOptions(PTERWND);

/***************************************************************************
                             FILE: TER_MISC.C 
****************************************************************************/
BOOL    AssignLongVal(HWND,int,LPLONG);
BOOL    AssignNumVal(HWND,int,LPINT);
BOOL    CellCharIncluded(PTERWND,long,int,long,int);
BOOL    CheckDlgValue(HWND,BYTE,int,double,double);
BOOL    CurrentPrinter(PTERWND,LPBYTE,LPBYTE,LPBYTE);
BOOL    IsCaretVisible(PTERWND,long,int);
BOOL    SearchDisplay(PTERWND,LPBYTE,BYTE,long,int,long,int);
BOOL    OpenCurPrinter(PTERWND);
BOOL    ParaCharIncluded(PTERWND,long,int,long,int);
BOOL    PrintError(PTERWND,LPBYTE); 
BOOL    RepairHdrFtrDelims(PTERWND,long,long);
BOOL    ReplaceTextString(PTERWND,LPBYTE,long,long);
BOOL    ReposPageHdrFtr(PTERWND,BOOL);
BOOL    SetDlgLong(HWND,int,long);
BOOL    StuffListBox(HWND,int,LPBYTE,DWORD);
BOOL    ToggleEditHdrFtr(PTERWND);
BOOL    ToggleHiddenText(PTERWND);
BOOL    ToggleViewHdrFtr(PTERWND);
BOOL    ToggleParaMark(PTERWND);
BOOL    ToggleRuler(PTERWND);
BOOL    ToggleStatusRibbon(PTERWND);
DWORD   sAlloc(UINT); 
DWORD   sReAlloc(DWORD,UINT); 
HGLOBAL TerGetMetaFileBits(HMETAFILE);
HMETAFILE TerSetMetaFileBits(HGLOBAL);
LPBYTE   DoubleToStr(double,int,LPBYTE);
LPBYTE   lstrchr(LPBYTE,BYTE);
LPBYTE   lstrlwr(LPBYTE);
LPBYTE   lstrupr(LPBYTE);
int     AdjustSections(PTERWND,long,long);
int     Bitmap2DIB(PTERWND,HBITMAP);
int     CallDialogBox(PTERWND,LPBYTE,DLGPROC,DWORD);
int     CheckLineLimit(PTERWND,long);
int     CreatePageHdrFtr(PTERWND,int,int);
int     DIB2Bitmap(PTERWND,HDC,int);
int     DisengageCaret(PTERWND);
int     ExtractDIB(PTERWND,HGLOBAL);
int     EngageCaret(PTERWND,int);
int     GetSection(PTERWND,long);
int     InitCaret(PTERWND);
int     OurPrintf(LPBYTE,...);
int     ParseUserString(PTERWND,LPBYTE,LPBYTE);
int     RecreateSections(PTERWND);
int     SetPictSize(PTERWND,int,int,int);
int     sFree(DWORD); 
int     sUnlock(DWORD); 
int     TerDestroyCaret(PTERWND);
int     TerJump(PTERWND);
int     TerReplaceString(PTERWND);
int     TerSearchBackward(PTERWND);
int     TerSearchForward(PTERWND);
int     TerSearchString(PTERWND);
int     TerSectionOptions(PTERWND);
int     TerTextExtentX(HDC,LPBYTE,int);  
HMETAFILE DIB2Metafile(PTERWND,int);
PTERWND GetWindowPointer(HWND); 
void    StrTrim(LPBYTE);
void    lTrim(LPBYTE);
void    rTrim(LPBYTE);
void    OurFree(void far *);
void    FarMemSet(void far *,BYTE,UINT);
void    FarMove(void far *,void far *,UINT);
void    FarMoveOl(void far *,void far *,UINT);
void    far *OurAlloc(DWORD);
void    far *OurRealloc(void far *,DWORD);
void    far *sLock(DWORD); 
void    HugeMove(void huge *,void huge *,long);
UINT    FarStringIndex(LPBYTE,LPBYTE);
UINT    FarStringRevIndex(LPBYTE,LPBYTE,UINT);
UINT    FarCharIndex(LPBYTE,BYTE,UINT);

/***************************************************************************
                             FILE: TER_OLE.C 
****************************************************************************/
#if defined (INC_OLE1)
   BOOL    PrintOleErrorMessage(PTERWND,LPBYTE,OLESTATUS);
   int     CALLBACK _export ClientCallback(LPOLECLIENT,OLE_NOTIFICATION,LPOLEOBJECT);
   int     TerOleWaitForRelease(PTERWND,LPOLEOBJECT);
#else
   BOOL    TerOlePreCreate(PTERWND,int,LPOLECLIENTSITE far *,LPSTORAGE far *,FORMATETC far *);
   BOOL    TerOlePostCreate(PTERWND,int);
   int     PrintOleError(PTERWND,HRESULT);
   LPOLECLIENTSITE CreateOleClientSite(PTERWND,int,LPSTORAGE);
   LPOLESTR StrToOleStr(LPSTR,LPSTR);
   HRESULT STDMETHODCALLTYPE IocsQueryInterface(LPOLECLIENTSITE,REFIID,LPVOID far *);
   ULONG   STDMETHODCALLTYPE IocsAddRef(LPOLECLIENTSITE);
   ULONG   STDMETHODCALLTYPE IocsRelease(LPOLECLIENTSITE);
   HRESULT STDMETHODCALLTYPE IocsGetContainer(LPOLECLIENTSITE,LPOLECONTAINER far *);
   HRESULT STDMETHODCALLTYPE IocsOnShowWindow(LPOLECLIENTSITE,BOOL);
   HRESULT STDMETHODCALLTYPE IocsGetMoniker(LPOLECLIENTSITE,DWORD,DWORD,LPMONIKER far *);
   HRESULT STDMETHODCALLTYPE IocsRequestNewObjectLayout(LPOLECLIENTSITE);
   HRESULT STDMETHODCALLTYPE IocsSaveObject(LPOLECLIENTSITE);
   HRESULT STDMETHODCALLTYPE IocsShowObject(LPOLECLIENTSITE);

   LPADVISESINK CreateAdviseSink(PTERWND, int, LPSTORAGE, LPOLECLIENTSITE);
   HRESULT STDMETHODCALLTYPE IasQueryInterface(LPADVISESINK,REFIID,LPVOID far *);
   ULONG   STDMETHODCALLTYPE IasAddRef(LPADVISESINK);
   ULONG   STDMETHODCALLTYPE IasRelease(LPADVISESINK);
   void    STDMETHODCALLTYPE IasOnDataChange(LPADVISESINK,FORMATETC far *, STGMEDIUM far *);
   void    STDMETHODCALLTYPE IasOnViewChange(LPADVISESINK,DWORD, LONG);
   void    STDMETHODCALLTYPE IasOnRename(LPADVISESINK,LPMONIKER);
   void    STDMETHODCALLTYPE IasOnSave(LPADVISESINK);
   void    STDMETHODCALLTYPE IasOnClose(LPADVISESINK);
#endif

BOOL    ExitOle(PTERWND);
BOOL    InitOle(PTERWND);
BOOL    TerInsertDragObject(PTERWND,HDROP);
BOOL    TerInsertObject(PTERWND);
BOOL    TerOleQuerySize(PTERWND,int,DWORD far *);
DWORD   CALLBACK _export TerOleGet(LPOLESTREAM,void FAR *,DWORD);
DWORD   CALLBACK _export TerOlePut(LPOLESTREAM,void FAR *,DWORD);
int     GetOleStorageData(PTERWND,int);
int     OlePostProcessing(PTERWND);
int     TerCreateTempOle(PTERWND,int);
int     TerEditOle(PTERWND); 
int     TerOleFromClipboard(PTERWND,UINT,BOOL); 
int     TerOleLoad(PTERWND,int);
int     TerOleUnload(PTERWND,int);
int     TerPasteSpecial(PTERWND);
UINT    GetOleClipItem(PTERWND,LPBYTE,LPBYTE,LPBYTE);

/***************************************************************************
                             FILE: TER_PAGE.C 
****************************************************************************/
BOOL    InitFrame(PTERWND,int);
int     AdjustSectColHeight(PTERWND,int,int,long,long);      
int     CreatePages(PTERWND);      
int     PageTextWidth(PTERWND,long);
int     PgmDown(PTERWND);
int     PgmLeft(PTERWND);
int     PgmPageDn(PTERWND);
int     PgmPageHorz(PTERWND,int);
int     PgmPageLeft(PTERWND,BOOL);
int     PgmPageRight(PTERWND,BOOL);
int     PgmPageUp(PTERWND);
int     PgmRight(PTERWND);
int     PgmUp(PTERWND);
int     PgmWinDown(PTERWND);
int     PgmWinLeft(PTERWND);
int     PgmWinRight(PTERWND);
int     PgmWinScroll(PTERWND,int,int);
int     PgmWinUp(PTERWND);
int     TerRepaginate(PTERWND,BOOL,BOOL);      
int     TogglePageMode(PTERWND);
int     UpdatePageNumber(PTERWND,long);
void    CreateFrames(PTERWND,BOOL);
void    CreateFramesScr(PTERWND);

/***************************************************************************
                             FILE: TER_RTF.C 
****************************************************************************/
BOOL    BeginRtfGroup(PTERWND,struct StrRtfOut far *);
BOOL    CopyRtfRow(PTERWND,struct StrRtf far *,struct StrRtfGroup far *,int);
BOOL    CreateRtfCell(PTERWND,struct StrRtf far *,struct StrRtfGroup far *,int);
BOOL    EndRtfGroup(PTERWND,struct StrRtfOut far *);
BOOL    FlushRtfLine(PTERWND,struct StrRtfOut far *);
BOOL    GetRtfChar(PTERWND,struct StrRtf far *);
BOOL    GetRtfHexChar(PTERWND,struct StrRtf far *);
BOOL    GetRtfWord(PTERWND,struct StrRtf far *);
BOOL    IsSameRtfParaFrame(struct StrRtfParaFrameInfo far *,struct StrRtfParaFrameInfo far *);
BOOL    MergeRtfLinePieces(PTERWND,long,long);
BOOL    ImportRtfData(PTERWND,int,struct StrRtfGroup far *,struct StrRtfGroup far *,LPBYTE);
BOOL    ImportRtfPicture(PTERWND,struct StrRtfGroup far *, struct StrRtfPict far *);
BOOL    ImportRtfTextLine(PTERWND,struct StrRtfGroup far *,LPBYTE);
BOOL    PushRtfChar(PTERWND,struct StrRtf far *);
BOOL    PutRtfChar(PTERWND,struct StrRtfOut far *,BYTE);
BOOL    PutRtfHexChar(PTERWND,struct StrRtfOut far *,BYTE);
BOOL    RtfRead(PTERWND,int,LPBYTE,BYTE huge *,long);  
BOOL    RtfWrite(PTERWND,int,LPBYTE);
BOOL    SendRtfText(PTERWND,struct StrRtf far *);
BOOL    SetRtfRowDefault(PTERWND,struct StrRtf far *,struct StrRtfGroup far *,int);
BOOL    WriteRtfCharFmt(PTERWND,struct StrRtfOut far *,int,int);
BOOL    WriteRtfControl(PTERWND,struct StrRtfOut far *,LPBYTE,int,double);
BOOL    WriteRtfDIB(PTERWND,struct StrRtfOut far *,int);
BOOL    WriteRtfCell(PTERWND,struct StrRtfOut far *,int);
BOOL    WriteRtfColor(PTERWND,struct StrRtfOut far *);
BOOL    WriteRtfFont(PTERWND,struct StrRtfOut far *);
BOOL    WriteRtfMargin(PTERWND,struct StrRtfOut far *);
BOOL    WriteRtfMetafile(PTERWND,struct StrRtfOut far *,int);
BOOL    WriteRtfObject(PTERWND,struct StrRtfOut far *,int);
BOOL    WriteRtfParaFmt(PTERWND,struct StrRtfOut far *,int,int);
BOOL    WriteRtfRow(PTERWND,struct StrRtfOut far *,int);
BOOL    WriteRtfSection(PTERWND,struct StrRtfOut far *,int);
BOOL    WriteRtfText(PTERWND,struct StrRtfOut far *,LPBYTE,int);
int     ReadRtfColorTable(PTERWND,struct StrRtf far *);
int     ReadRtfField(PTERWND,struct StrRtf far *);
int     ReadRtfFontTable(PTERWND,struct StrRtf far *);
int     ReadRtfObject(PTERWND,struct StrRtf far *rtf);
int     ReadRtfPicture(PTERWND,struct StrRtf far *);
int     SetRtfParaId(PTERWND,long,struct StrRtfGroup far *);
int     SkipRtfGroup(PTERWND,struct StrRtf far *);

/***************************************************************************
                             FILE: TBL_TBL.C 
****************************************************************************/
int     GetCellColumn(PTERWND,int);
int     GetCellRightX(PTERWND,int);
int     GetCellSlot(PTERWND,BOOL);
int     GetNextCellInColumn(PTERWND,int);
int     GetNextCellInColumnPos(PTERWND,int);
int     GetPrevCellInColumn(PTERWND,int,BOOL);
int     GetPrevCellInColumnPos(PTERWND,int,BOOL);
int     GetRowCell(PTERWND,int,int);
int     GetTableRowSlot(PTERWND);
int     MarkCells(PTERWND,int);
int     RecoverCellSlots(PTERWND);
int     RecoverTableRowSlots(PTERWND);
int     RepairTable(PTERWND);
int     TerCellBorder(PTERWND);
int     TerCellShading(PTERWND);
int     TerDeleteCells(PTERWND);
int     TerInsertTableRow(PTERWND);
int     TerMergeCells(PTERWND);
int     TerRowPosition(PTERWND);
int     TerSplitCell(PTERWND);  
int     TerTabCell(PTERWND);
int     TerToggleTableGrid(PTERWND);

