// ter_view.h : Interface to the CTerView Class
//
// This class is derived from the CView class.  Therefore, if your
// application derives a class from the CTerView class and adds it
// to the template using CWinApp::AddDocTemplate, the framework
// will call both the constructor and the 'Create' function.
//
// Sub Systems, Inc.
// Copyright 1994.
// 159 Main Street, #8C
// Stoneham, MA 02180
/////////////////////////////////////////////////////////////////////////////

#include "ter.h"

class CTerView : public CView
{
       DECLARE_DYNCREATE(CTerView)

// Construction
protected:
       CTerView();

// Attributes
public:
        virtual WORD EditStyles();        // return edit style constants (TER_)
        BOOL         MenuEnable(int);     // TRUE if menu item should be enabled
        int          MenuSelect(int);     // 0=unchecked, 1=checked

// Operations
public:
        void         SerializeRaw(CArchive &ar);

// Implementation
public:
        virtual      ~CTerView();
        virtual void DeleteContents();
        virtual void OnDraw(CDC *pDC);
        virtual BOOL OnPreparePrinting(CPrintInfo *pInfo);
        virtual void OnPrint(CDC *pDC, CPrintInfo *pInfo);
        virtual void Serialize(CArchive &ar);
        void         ReadArchive(CArchive &ar, DWORD len);
        void         WriteArchive(CArchive &ar);

protected:
        HGLOBAL      m_hBuffer;   // handle to the retrieved buffer
        DWORD        m_BufLen;    // buffer length

        DWORD        GetBuffer(); // retrieve the text buffer

// Construction
protected:
        LRESULT      TerWindowProc(UINT,WPARAM,LPARAM);
        void         TerMenu(WPARAM);
        WNDPROC      *GetSuperWndProcAddr();
        virtual BOOL PreCreateWindow(CREATESTRUCT &cs);

// Printing support
protected:

// Generated message map functions
protected:
        //{{AFX_MSG(CTerView)
        afx_msg void OnPaint();
        afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
        afx_msg void OnEditCopy();
        afx_msg void OnEditCut();
        afx_msg void OnEditPaste();
        afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
        afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
        afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
        afx_msg void OnEditUndo();
        afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
        afx_msg void OnEditHdrFtr();
        afx_msg void OnUpdateEditHdrFtr(CCmdUI* pCmdUI);
        afx_msg void OnFilePrint();
        afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
        afx_msg void OnFilePrintPreview();
        afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
        afx_msg void OnFontBold();
        afx_msg void OnUpdateFontBold(CCmdUI* pCmdUI);
        afx_msg void OnFontDoubleunderline();
        afx_msg void OnUpdateFontDoubleunderline(CCmdUI* pCmdUI);
        afx_msg void OnFontFonts();
        afx_msg void OnUpdateFontFonts(CCmdUI* pCmdUI);
        afx_msg void OnFontHidden();
        afx_msg void OnUpdateFontHidden(CCmdUI* pCmdUI);
        afx_msg void OnFontItalic();
        afx_msg void OnUpdateFontItalic(CCmdUI* pCmdUI);
        afx_msg void OnFontNormal();
        afx_msg void OnUpdateFontNormal(CCmdUI* pCmdUI);
        afx_msg void OnFontProtect();
        afx_msg void OnUpdateFontProtect(CCmdUI* pCmdUI);
        afx_msg void OnFontStrikethrough();
        afx_msg void OnUpdateFontStrikethrough(CCmdUI* pCmdUI);
        afx_msg void OnFontSubscript();
        afx_msg void OnUpdateFontSubscript(CCmdUI* pCmdUI);
        afx_msg void OnFontSuperscript();
        afx_msg void OnUpdateFontSuperscript(CCmdUI* pCmdUI);
        afx_msg void OnFontUnderline();
        afx_msg void OnUpdateFontUnderline(CCmdUI* pCmdUI);
        afx_msg void OnFontColor();
        afx_msg void OnUpdateFontColor(CCmdUI* pCmdUI);
        afx_msg void OnFontBkColor();
        afx_msg void OnUpdateFontBkColor(CCmdUI* pCmdUI);
        afx_msg void OnViewHiddentext();
        afx_msg void OnUpdateViewHiddentext(CCmdUI* pCmdUI);
        afx_msg void OnViewPagemode();
        afx_msg void OnUpdateViewPagemode(CCmdUI* pCmdUI);
        afx_msg void OnViewParagraphmarker();
        afx_msg void OnUpdateViewParagraphmarker(CCmdUI* pCmdUI);
        afx_msg void OnViewRuler();
        afx_msg void OnUpdateViewRuler(CCmdUI* pCmdUI);
        afx_msg void OnViewHyperlinkCursor();
        afx_msg void OnUpdateViewHyperlinkCursor(CCmdUI* pCmdUI);
        afx_msg void OnViewHdrFtr();
        afx_msg void OnUpdateViewHdrFtr(CCmdUI* pCmdUI);
        afx_msg void OnInsertColumnbreak();
        afx_msg void OnUpdateInsertColumnbreak(CCmdUI* pCmdUI);
        afx_msg void OnInsertPagebreak();
        afx_msg void OnUpdateInsertPagebreak(CCmdUI* pCmdUI);
        afx_msg void OnInsertSectionbreak();
        afx_msg void OnUpdateInsertSectionbreak(CCmdUI* pCmdUI);
        afx_msg void OnInsertObject();
        afx_msg void OnUpdateInsertObject(CCmdUI* pCmdUI);
        afx_msg void OnInsertPicture();
        afx_msg void OnUpdateInsertPicture(CCmdUI* pCmdUI);
        afx_msg void OnBlockCopy();
        afx_msg void OnUpdateBlockCopy(CCmdUI* pCmdUI);
        afx_msg void OnBlockMove();
        afx_msg void OnUpdateBlockMove(CCmdUI* pCmdUI);
        afx_msg void OnDelLine();
        afx_msg void OnUpdateDelLine(CCmdUI* pCmdUI);
        afx_msg void OnEditPict();
        afx_msg void OnUpdateEditPict(CCmdUI* pCmdUI);
        afx_msg void OnInsAft();
        afx_msg void OnUpdateInsAft(CCmdUI* pCmdUI);
        afx_msg void OnInsBef();
        afx_msg void OnUpdateInsBef(CCmdUI* pCmdUI);
        afx_msg void OnJoinLine();
        afx_msg void OnUpdateJoinLine(CCmdUI* pCmdUI);
        afx_msg void OnPasteSpec();
        afx_msg void OnUpdatePasteSpec(CCmdUI* pCmdUI);
        afx_msg void OnRepaginate();
        afx_msg void OnUpdateRepaginate(CCmdUI* pCmdUI);
        afx_msg void OnSectOptions();
        afx_msg void OnUpdateSectOptions(CCmdUI* pCmdUI);
        afx_msg void OnSelectAll();
        afx_msg void OnUpdateSelectAll(CCmdUI* pCmdUI);
        afx_msg void OnSplitLine();
        afx_msg void OnUpdateSplitLine(CCmdUI* pCmdUI);
        afx_msg void OnCenter();
        afx_msg void OnUpdateCenter(CCmdUI* pCmdUI);
        afx_msg void OnDoubleSpace();
        afx_msg void OnUpdateDoubleSpace(CCmdUI* pCmdUI);
        afx_msg void OnHangingIndent();
        afx_msg void OnUpdateHangingIndent(CCmdUI* pCmdUI);
        afx_msg void OnParaBorder();
        afx_msg void OnUpdateParaBorder(CCmdUI* pCmdUI);
        afx_msg void OnParaNormal();
        afx_msg void OnUpdateParaNormal(CCmdUI* pCmdUI);
        afx_msg void OnRightIndent();
        afx_msg void OnUpdateRightIndent(CCmdUI* pCmdUI);
        afx_msg void OnRightJustify();
        afx_msg void OnUpdateRightJustify(CCmdUI* pCmdUI);
        afx_msg void OnJustify();
        afx_msg void OnUpdateJustify(CCmdUI* pCmdUI);
        afx_msg void OnTabClear();
        afx_msg void OnUpdateTabClear(CCmdUI* pCmdUI);
        afx_msg void OnTabClearAll();
        afx_msg void OnUpdateTabClearAll(CCmdUI* pCmdUI);
        afx_msg void OnLeftIndent();
        afx_msg void OnUpdateLeftIndent(CCmdUI* pCmdUI);

        afx_msg void OnTableInsert();
        afx_msg void OnUpdateTableInsert(CCmdUI* pCmdUI);
        afx_msg void OnTableInsertRow();
        afx_msg void OnUpdateTableInsertRow(CCmdUI* pCmdUI);
        afx_msg void OnTableSplitCell();
        afx_msg void OnUpdateTableSplitCell(CCmdUI* pCmdUI);
        afx_msg void OnTableMergeCells();
        afx_msg void OnUpdateTableMergeCells(CCmdUI* pCmdUI);
        afx_msg void OnTableDelCells();
        afx_msg void OnUpdateTableDelCells(CCmdUI* pCmdUI);
        afx_msg void OnTableShowGrid();
        afx_msg void OnUpdateTableShowGrid(CCmdUI* pCmdUI);
        afx_msg void OnTableRowPos();
        afx_msg void OnUpdateTableRowPos(CCmdUI* pCmdUI);
        afx_msg void OnTableCellBorder();
        afx_msg void OnUpdateTableCellBorder(CCmdUI* pCmdUI);
        afx_msg void OnTableCellShade();
        afx_msg void OnUpdateTableCellShade(CCmdUI* pCmdUI);

        afx_msg void OnFileBegin();
        afx_msg void OnUpdateFileBegin(CCmdUI* pCmdUI);
        afx_msg void OnFileEnd();
        afx_msg void OnUpdateFileEnd(CCmdUI* pCmdUI);
        afx_msg void OnJump();
        afx_msg void OnUpdateJump(CCmdUI* pCmdUI);
        afx_msg void OnLineBegin();
        afx_msg void OnUpdateLineBegin(CCmdUI* pCmdUI);
        afx_msg void OnLineEnd();
        afx_msg void OnUpdateLineEnd(CCmdUI* pCmdUI);
        afx_msg void OnNextWord();
        afx_msg void OnUpdateNextWord(CCmdUI* pCmdUI);
        afx_msg void OnPrevWord();
        afx_msg void OnUpdatePrevWord(CCmdUI* pCmdUI);
        afx_msg void OnProtectionLock();
        afx_msg void OnUpdateProtectionLock(CCmdUI* pCmdUI);
        afx_msg void OnReplace();
        afx_msg void OnUpdateReplace(CCmdUI* pCmdUI);
        afx_msg void OnSearch();
        afx_msg void OnUpdateSearch(CCmdUI* pCmdUI);
        afx_msg void OnSearchBack();
        afx_msg void OnUpdateSearchBack(CCmdUI* pCmdUI);
        afx_msg void OnSearchFor();
        afx_msg void OnUpdateSearchFor(CCmdUI* pCmdUI);
        afx_msg void OnHelp();
        afx_msg void OnUpdateHelp(CCmdUI* pCmdUI);
        //}}AFX_MSG
        
        // message defined outside of Class Wizzard
        afx_msg void OnEditChange();
        afx_msg void OnViewStatusBar();                      // also inmplemented by the frame window
        afx_msg void OnUpdateViewStatusBar(CCmdUI* pCmdUI);  // also implemented by the frame window
        afx_msg void OnViewToolbar();                        // also implemented by the frame window
        afx_msg void OnUpdateViewToolbar(CCmdUI* pCmdUI);    // also implemented by the frame window

        DECLARE_MESSAGE_MAP()
};

